Subject: Re: [PATCH RFC 1/2] net: dsa: integrate with SWITCHDEV for HW bridging

From: Guenter Roeck <[email-masked]>
Date: Mon, 23 Feb 2015 10:35:37 -0800

On Mon, Feb 23, 2015 at 10:05:41AM -0800, Florian Fainelli wrote:
> On 23/02/15 08:01, Andrew Lunn wrote:
> >> I currently use ATU command 110 (flush all non-static entries in a
> >> particular FID). I see means to flush either all entries or all
> >> non-static entries, but no means to only flush unicast or multicast
> >> entries. Does any of the standards distinguish between learned unicast
> >> and multicast addresses ? Flushing those selectively might be a
> >> challenge.
> 
> Lucky you, on Broadcom switches you have to issue an ARL search, get the
> results (there are all valid MAC entries, fortunately), and invalidate
> the entries one by one for your particular ports of interest, there is
> no "flush all non-static entries".
> 
> > 
> > You might need to walk the table and flush records individually if you
> > are only interested in one type.
> > 
> > We should also consider do we need to make these flush operations
> > atomic with respect to other operations? Do we need to disable
> > learning, flush, change the port STP status, and then enable learning?
> 
Wonder what if anything RSTP specifies for flush operation details.

> I think we may have to do this to guarantee no race conditions between
> flushing the switch's FDB, although it would look like only "joining" a
> bridge needs to be a more controlled operation, on leave we can probably
> just leave the bridge, flush entries and the switch port will start
> learning new MAC addresses, right?
> 
> Alternatively, would not setting a very low aging timeout and
> maintaining HW learning still allow us to simplify these operations?

That is what STP specifies. With RSTP, the expectation is that the database
is flushed immediately on port status changes. Also, the minimum aging
period on Marvell switches is 15 seconds, which is way too long for RSTP.

Guenter